function mux1(...iters) {
  return new MuxAsyncIterable(iters);
}
class MuxAsyncIterable {
  iters;
  nexts;
  constructor(iters1) {
    this.iters = iters1;
    this.nexts = this.iters.map((iter) => iter.next());
  }
  async next() {
    while (this.iters.length > 0) {
      const { next } = await Promise.race(this.nexts.map(async (next) => {
        await next;
        return {
          next,
        };
      }));
      const i = this.nexts.indexOf(next);
      const res = await next;
      if (res.done) {
        this.nexts.splice(i, 1);
        this.iters.splice(i, 1);
        continue;
      }
      if (!res.done) {
        this.nexts.splice(i, 1, this.iters[i].next());
        return {
          done: false,
          value: res.value,
        };
      }
    }
    return {
      done: true,
      value: undefined,
    };
  }
  [Symbol.asyncIterator]() {
    return this;
  }
}
export { mux1 as mux };
